@import '../../../styles/mixins';
@import '../../../styles/props';

// local variables
// for header
$header-height: 35px;
$year-month-gap: 5px;

// for year
$year-font-size: 14px;
$year-color: #000;

// for month
$month-font-size: 14px;
$month-color: #000;

// for day
$day-height: 30px;
$day-font-size: 12px;
$day-color: #aaa;

// for date
$date-height: $field-height;
$date-font-size: 12px;
$date-color: #000;
$date-out-color: $very-light-grey;
$date-today-color: $primary;
$date-current-color: #fff;
$date-current-background: $date-today-color;
$date-hover-background: #eee;

// for controls
$controls-height: 35px;
$control-font-size: 12px;
$control-color: #000;
$control-hover-color: rgba($control-color, 0.5);
$control-gap: 10px;
$control-arrow-size: 24px;

:host {
  display: block;
  user-select: none;
}

// calendar header
.app-calendar-header {
  @include flex(center, center);
  height: $header-height;
}

// year
.app-calendar-year {
  font-size: $year-font-size;
  color: $year-color;
}

// month
.app-calendar-month {
  font-size: $month-font-size;
  color: $month-color;
  margin-left: $year-month-gap;
}

// days wrapper
.app-calendar-days {
  @include flex(center);
}

// day
.app-calendar-day {
  @include flex(center, center);
  width: calc(100% / 7);
  height: $day-height;
  font-size: $day-font-size;
  color: $day-color;
}

// dates wrapper
.app-calendar-dates {
  @include flex();
}

// date
.app-calendar-date {
  @include flex(center, center);
  width: calc(100% / 7);
  height: $date-height;
  font-size: $date-font-size;
  color: $date-color;
  cursor: pointer;

  // hover
  &:hover {
    background-color: $date-hover-background;
  }

  // out of calendar
  &.out-of-calendar {
    color: $date-out-color;
  }

  // today date
  &.today {
    color: $date-today-color;
  }

  // current date
  &.current {
    color: $date-current-color;
    background-color: $date-current-background;
  }
}

// controls
.app-calendar-controls {
  @include flex(center, flex-end);
  height: $controls-height;
}

// control
.app-calendar-control {
  font-size: $control-font-size;
  color: $control-color;
  cursor: pointer;

  &:hover {
    color: $control-hover-color;

    .app-icon {
      ::ng-deep {
        path {
          fill: $control-hover-color;
        }
      }
    }
  }

  & + .app-calendar-control {
    margin-left: $control-gap;
  }

  // for arrow controllers
  &.arrow {
    @include flex(center, center);
    @include box($control-arrow-size);
  }

  &.app-disabled {
    .app-icon {
      ::ng-deep {
        path {
          fill: $very-light-grey;
        }
      }
    }
  }
}
